/*
 * BarChartVis.java
 *
 * Created on 9. Mai 2007, 14:16
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package zugvis;

import at.ac.tuwien.cs.timevis.ui.TimeScaleHeader;
import java.awt.BorderLayout;
import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;
import java.util.GregorianCalendar;
import java.util.Vector;
import javax.swing.JPanel;
import javax.swing.JTabbedPane;
import prefuse.data.Table;
import zugvis.BarChartVis.BarChartDisplay;
import zugvis.BarChartVis.MouseTrackerBarChart;


/**
 * This class contains the functionality for the duration bar chart.
 * @author Hansjoerg
 */
public class BarChartVisRel extends BarChartVis {
    
    /**
     * Table of dates
     */
    private Table dates = null;
    
    /**
     * The display of the visualization
     */
    private BarChartDisplay barChartDisplay = null;    
    
    
    /**
     * Creates a new instance of BarChartVisRel
     * @param tabPane Tabpane that contains this visualisation (for propertychangeeventes)
     * @param selectedTrains Vector fo selected trains
     * @param connections Table of connections
     * @param stations Table of stations
     * @param trains Table of trains
     * @param dates Table of dates
     */
    public BarChartVisRel(JTabbedPane tabPane, Vector selectedTrains, Table connections, Table stations, Table trains, Table dates) {
        
        super();
        
        this.selectedTrains = selectedTrains;
        this.dates = dates;
        
        connections = Functions.deleteStopOvers(connections);
        connections = Functions.getSortedConnections(connections, false);
        connections = Functions.addInternalConnectionIDs(connections);
        tabPane.firePropertyChange("_PUSHPROGRESS_", 0, 5);
        data = Functions.makeRelData(connections, stations, trains, dates);
        tabPane.firePropertyChange("_PUSHPROGRESS_", 0, 5);
        data = Functions.addTrainInfo(data, trains);
        data = Functions.addStationNames(data, stations);
        data = Functions.addTipText(data, dates, true);
        
        barChartDisplay = new BarChartDisplay(data, false);
        barChartDisplay.timeScale.setDisplayWidth(barChartDisplay.getWidth() - 1);
        barChartDisplay.timeScale.changeInterval(Functions.getEarliestDate(data, new GregorianCalendar()).getTime().getTime(), Functions.getLatestDate(data, new GregorianCalendar()).getTime().getTime()+1000*60*10);
        barChartDisplay.mouseTracker = new MouseTrackerBarChart(barChartDisplay, barChartDisplay.timeScale, true);
        
        JPanel JPanelVis = new JPanel();
        JPanelVis.setLayout(new BorderLayout());
        JPanelVis.add(barChartDisplay, BorderLayout.CENTER);
        JPanelVis.add(makeJRangeSlider_Y(barChartDisplay), BorderLayout.EAST);
        JPanelVis.add(new TimeScaleHeader(barChartDisplay.timeScale), BorderLayout.NORTH);
        
        add(JPanelVis, BorderLayout.CENTER);
        
        addPropertyChangeListener(new PropertyChangeListener() {
            public void propertyChange(PropertyChangeEvent evt) {
                
                if (evt.getPropertyName().equals("_REPAINT_"))
                    barChartDisplay.getVisualization().run("repaint");
                
                if (evt.getPropertyName().equals("_SETDIRECTION_")) {
                    
                    direction = (int)Functions.object2Long(evt.getNewValue());
                    barChartDisplay.getVisualization().run("repaint");
                }
                
                if (evt.getPropertyName().equals("_SHOWSTATIONS_")) { 
                    
                    long newVal = Functions.object2Long(evt.getNewValue());
                    barChartDisplay.barRenderer.DrawStations(newVal == 1 ? true : false);
                    barChartDisplay.getVisualization().run("repaint");
                }
            }    
        });
    } 
}
