/*
 * LineTimeScalePainter.java
 *
 * Created on June 8, 2007, 5:26 PM
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package zugvis;


import java.awt.Component;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.Color;
import java.util.Calendar;
import javax.swing.JComponent;

import at.ac.tuwien.cs.timevis.ui.TimeScalePainter;
import at.ac.tuwien.cs.timevis.BasicTimeScale;
import at.ac.tuwien.cs.timevis.TimeUnit;
import at.ac.tuwien.cs.timevis.TimeUnitProvider;
import at.ac.tuwien.cs.timevis.util.DateUtil;
/**
 * This class is very much like the TimeVis class TimeScalePainter. The difference is that it leaves a border at the left side of the screen. 
 * The size of this border can be set in the constructor.
 * @author Georg Prohaska
 */
public class LineTimeScalePainter extends TimeScalePainter{
    private int border = 0;
    /**
     * Creates a new instance of LineTimeScalePainter
     * @param _border The size of the border in pixels.
     */
    public LineTimeScalePainter(JComponent comp, int _border) {
        super(comp);
        border = _border;
    }
    
    public void drawUnits(Graphics g, TimeUnit timeUnit, boolean smallUnit) {
	int x = 0;
	int weekendBegin = 0;
	boolean weekend = false;
	Calendar cal = Calendar.getInstance();
		cal.setTimeInMillis(timeUnit.previous(getTimeScale().getStartDate()));


		while (x < getComponent().getWidth()) {
			g.setColor(getLineColor());
			x = (int) getTimeScale().getPixelForDate(cal.getTimeInMillis());
                        
			if(x > border) drawUnit(g, timeUnit, cal.getTimeInMillis(), x, smallUnit);

			if (smallUnit) {
				if (weekend && timeUnit.compareTo(getTimeScale().getTimeUnitProvider().getWeekUnit()) < 0) {
					highlightWeekend(g, x, weekendBegin);
				}
				if (DateUtil.isWeekend(cal)) {
					weekend = true;
					weekendBegin = x;
				} else {
					weekend = false;
				}
			}

			cal.setTimeInMillis(timeUnit.next(cal.getTimeInMillis()));
    	}
    }
}
