package zugvis;
import prefuse.data.Table;
import com.toedter.calendar.JCalendar;
import com.toedter.calendar.JDateChooser;
import java.util.GregorianCalendar;
import java.util.Date;
import java.util.Calendar;
import java.awt.*;
import javax.swing.*;
import java.awt.event.*;
import java.beans.PropertyChangeEvent;
import java.text.SimpleDateFormat;
import javax.swing.text.*;
import java.awt.*;
import java.text.*;
import java.util.*;
import javax.swing.text.html.*;
import javax.swing.text.StyleConstants.*;
import java.awt.Color;
import javax.swing.*;
import javax.swing.text.*;
import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;
       
/**
 * TextVis.java
 */
public class TextVis extends JPanel {
    
    private Table data = null;
    Date fromDate = new Date();
    Date toDate = new Date();
    int direction = 0;
    
    /**
     * stores data in local variables
     * @param connections connections stored in local variable data
     * @param stations stations  stored in local variable data
     * @param trains trains stored in local variable data
     * @param dates dates stored in local variable data
     */
    public TextVis(Table connections, Table stations, Table trains, Table dates) {
        
        connections = Functions.deleteStopOvers(connections);
        data = Functions.makeData(connections, stations, trains, dates);
        data = Functions.addTrainInfo(data, trains);
        data = Functions.addStationNames(data, stations);
        
        final Steuerleiste steuer = new Steuerleiste();
        
        addPropertyChangeListener(new PropertyChangeListener() {

            public void propertyChange(PropertyChangeEvent evt) {

                if (evt.getPropertyName().equals("_STARTDATE_")) {                  

                    GregorianCalendar tempD = new GregorianCalendar();
                    tempD.setTimeInMillis(Functions.object2Long(evt.getNewValue()));
                    tempD.set(tempD.get(tempD.YEAR), tempD.get(tempD.MONTH), tempD.get(tempD.DAY_OF_MONTH), 0, 0, 0);
                    Date temp = new Date();
                    fromDate = tempD.getTime();
                }
              
                if (evt.getPropertyName().equals("_ENDDATE_")) { 
                    
                    GregorianCalendar tempD = new GregorianCalendar();
                    tempD.setTimeInMillis(Functions.object2Long(evt.getNewValue()));
                    tempD.set(tempD.get(tempD.YEAR), tempD.get(tempD.MONTH), tempD.get(tempD.DAY_OF_MONTH), 23, 59, 59);
                    Date temp = new Date();
                    toDate = tempD.getTime();                   
                }
                
                if (evt.getPropertyName().equals("_SETDIRECTION_")) {                  

                   direction = (int)Functions.object2Long(evt.getNewValue());
                }
                
                steuer.actionPerformed(fromDate, toDate, direction);
            }            
        });
    }
    
    /**
     * Defines labels and output panel
     */
    public class Steuerleiste {
        
        JLabel Einleitung;
        JLabel Datumausgewhlt;
        JLabel Datumausgabe;
        Date SelectedDate;
        String SelectedfromDateString;
        String SelectedtoDateString;
        JTextPane Ergebnis;
        String Begruessung;
        String Menueleiste;
        String Zugbezeichnung;       
        String Datumergebnis;
        String Datumergebnis2;       
        String Abfahrtsort;       
        String Ankunftsort;
        Document doc;
                    
        Steuerleiste() {          
            
            Einleitung = new JLabel("Spezifizieren Sie ein Datum oder einen Zeitraum");            
            
            Datumausgewhlt = new JLabel("Sie haben folgenden Zeitraum ausgewhlt:");
            Datumausgabe = new JLabel();
            
            Color TextPane = new Color(204,204,204);
            Ergebnis = new JTextPane();
            Ergebnis.setEditable(false);
            Ergebnis.setContentType("text/html");
            Ergebnis.setBackground(TextPane);
           
            final JScrollPane ScrollPane = new JScrollPane(Ergebnis);
            ScrollPane.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
            ScrollPane.setHorizontalScrollBarPolicy(JScrollPane.HORIZONTAL_SCROLLBAR_ALWAYS);
            ScrollPane.setPreferredSize(new Dimension(700, 310));
            
                         
            addComponentListener(new ComponentAdapter() {
                public void componentResized(ComponentEvent e) {
                    
                    int breite = getWidth();
                    int hoehe = getHeight();
                    if(breite != 744 && hoehe != 372){
                    ScrollPane.setPreferredSize(new Dimension(getWidth()-50, getHeight()-60));
                    }
                }
            });

            
            setLayout(new BorderLayout());
            JPanel NorthPanel = new JPanel();
            JPanel CenterPanel = new JPanel();
            JPanel SouthPanel = new JPanel();
            
            NorthPanel.add(Einleitung);
            SouthPanel.add(Datumausgewhlt);
            SouthPanel.add(Datumausgabe);
            CenterPanel.add(ScrollPane);
                                 
            add(BorderLayout.CENTER, CenterPanel);
            add(BorderLayout.NORTH, NorthPanel);
            add(BorderLayout.SOUTH, SouthPanel);
        }
        
        /**
         * Calls searchForTrains for the current intervall and sets JLabels correctly
         * @param fromDate the fromDate specified by JDateChooser
         * @param toDate the toDate specified by JDateCHooser
         * @param direction indicator for the current selected direction
         */
        public void actionPerformed(Date fromDate, Date toDate, int direction) {
            Ergebnis.setText("");
            SimpleDateFormat sd = new SimpleDateFormat("dd.MM.yyyy");
            SelectedfromDateString = sd.format(fromDate);
            SelectedtoDateString = sd.format(toDate);
            Datumausgabe.setText(" " + SelectedfromDateString + " " + "-" + " " + SelectedtoDateString); 
            
            GregorianCalendar fromDateCalendar = new GregorianCalendar();
            GregorianCalendar toDateCalendar = new GregorianCalendar();
            fromDateCalendar.setTime(fromDate);
            toDateCalendar.setTime(toDate);
            
            
            while (fromDateCalendar.compareTo(toDateCalendar) <= 0) {
                searchForTrains(fromDateCalendar, SelectedfromDateString, direction);
                fromDateCalendar.add(Calendar.DAY_OF_MONTH, 1);
                Date updatetDate = fromDateCalendar.getTime();
                SelectedfromDateString = sd.format(updatetDate);
                        }           
        }
        
        
        /**
         * search the database and displays found items
         * @param fromDateCalendar current selected Date
         * @param SelectedfromDateString used for output on JPanel
         * @param direction indicator for the current direction
         * @return returns string
         */
        public String searchForTrains(GregorianCalendar fromDateCalendar, String SelectedfromDateString, int direction) {
            
            Document doc = Ergebnis.getStyledDocument();
            Date searchDate = fromDateCalendar.getTime();      
           
            Color BegruessungFarbe = new Color(204,51,51);
            SimpleAttributeSet BegruessungFormat = new SimpleAttributeSet();
            StyleConstants.setFontSize(BegruessungFormat, 15);
            StyleConstants.setBold(BegruessungFormat, true);
            StyleConstants.setUnderline(BegruessungFormat,true);
            StyleConstants.setAlignment(BegruessungFormat, 1);
            StyleConstants.setSpaceAbove(BegruessungFormat, 10);
            StyleConstants.setItalic(BegruessungFormat,true);
            StyleConstants.setForeground(BegruessungFormat,BegruessungFarbe);
            
            SimpleAttributeSet newlineformat = new SimpleAttributeSet();          

                               
            Color MenueleisteFarbe = new Color(153,153,153);
            SimpleAttributeSet MenueleisteFormat = new SimpleAttributeSet();
            StyleConstants.setFontSize(MenueleisteFormat, 12);
            StyleConstants.setBold(MenueleisteFormat, true);
            StyleConstants.setUnderline(MenueleisteFormat,true);
            StyleConstants.setAlignment(MenueleisteFormat, 1);
            StyleConstants.setSpaceAbove(MenueleisteFormat, 20);
            StyleConstants.setBackground(MenueleisteFormat,MenueleisteFarbe);            
 
            String newline = "\n";
            Begruessung = "Fahrplan fr den:" + " " + SelectedfromDateString;
            Menueleiste = "Zugname:" + "   " + "Abfahrt:" + "    " + "Abfahrtsort:" + "          -Nach-          " + "Ankunftsort:" + "                     " + "Ankunft:";
                            
                             try{                              
                                doc.insertString(doc.getLength(), Begruessung + newline , BegruessungFormat);
                                doc.insertString(doc.getLength(), Menueleiste + newline, MenueleisteFormat);
                                }
                            catch (BadLocationException ble) 
                                {                               
                            System.err.println("Error");
                                }
            
            GregorianCalendar selectedDate = new GregorianCalendar();
            selectedDate.setTime(searchDate);
            GregorianCalendar tempD = new GregorianCalendar();
            GregorianCalendar tempTo = new GregorianCalendar();
            
            
            for (int i = 0; i < data.getRowCount(); i++) {
                
               
                tempD.setTime(data.getDate(i, "fromTime")); 
                tempTo.setTime(data.getDate(i, "toTime"));
                
                if ( tempD.get(tempD.YEAR) == selectedDate.get(selectedDate.YEAR) &&
                        tempD.get(tempD.MONTH) == selectedDate.get(selectedDate.MONTH) &&
                        tempD.get(tempD.DAY_OF_MONTH) == selectedDate.get(selectedDate.DAY_OF_MONTH) &&
                        direction == 0 ) 
                      
                {                                                                                                                                         
                      Zugbezeichnung = data.getString(i, "trainName");
                      Zugbezeichnung = fillup(Zugbezeichnung,8);
                      Datumergebnis = tempD.getTime().toLocaleString();
                      Datumergebnis = Datumergebnis.substring(10);
                      Datumergebnis = Datumergebnis.trim();
                      Abfahrtsort = data.getString(i, "fromName");
                      Abfahrtsort = fillup(Abfahrtsort,25);
                      Ankunftsort = data.getString(i, "toName");
                      Ankunftsort = fillup(Ankunftsort,25);
                      Datumergebnis2 = tempTo.getTime().toLocaleString();
                      Datumergebnis2 = Datumergebnis2.substring(10);
                      Datumergebnis2 = Datumergebnis2.trim();
                      String Ausgabe = Zugbezeichnung +"   "+ Datumergebnis + "  "+ Abfahrtsort +"      "+ Ankunftsort +"  "+ Datumergebnis2;
   
                      SimpleAttributeSet Normal = new SimpleAttributeSet();                      
                      StyleConstants.setFontFamily(Normal,"Courier");                     
                      StyleConstants.setFontSize(Normal, 11);
                      StyleConstants.setAlignment(Normal, 1);
                      StyleConstants.setSpaceAbove(Normal, 5);
                      
                            try{                              
                                doc.insertString(doc.getLength(), Ausgabe + newline ,Normal);                                
                                }
                            catch (BadLocationException ble) 
                                {                               
                            System.err.println("Error");
                                }                                  
                }

                if ( tempD.get(tempD.YEAR) == selectedDate.get(selectedDate.YEAR) &&
                        tempD.get(tempD.MONTH) == selectedDate.get(selectedDate.MONTH) &&
                        tempD.get(tempD.DAY_OF_MONTH) == selectedDate.get(selectedDate.DAY_OF_MONTH) &&
                        direction == 1 &&                        
                        data.getInt(i,"fromKm")<= data.getInt(i,"toKm")) 
                      
                {                                                                                                                                        
                      Zugbezeichnung = data.getString(i, "trainName");
                      Zugbezeichnung = fillup(Zugbezeichnung,8);
                      Datumergebnis = tempD.getTime().toLocaleString();
                      Datumergebnis = Datumergebnis.substring(10);
                      Datumergebnis = Datumergebnis.trim();
                      Abfahrtsort = data.getString(i, "fromName");
                      Abfahrtsort = fillup(Abfahrtsort,25);
                      Ankunftsort = data.getString(i, "toName");
                      Ankunftsort = fillup(Ankunftsort,25);
                      Datumergebnis2 = tempTo.getTime().toLocaleString();
                      Datumergebnis2 = Datumergebnis2.substring(10);
                      Datumergebnis2 = Datumergebnis2.trim();
                      String Ausgabe = Zugbezeichnung +"   "+ Datumergebnis + "  "+ Abfahrtsort +"      "+ Ankunftsort +"  "+ Datumergebnis2;
   
                      SimpleAttributeSet Normal = new SimpleAttributeSet();                      
                      StyleConstants.setFontFamily(Normal,"Courier");                     
                      StyleConstants.setFontSize(Normal, 11);
                      StyleConstants.setAlignment(Normal, 1);
                      StyleConstants.setSpaceAbove(Normal, 5);
                      
                            try{                              
                                doc.insertString(doc.getLength(), Ausgabe + newline ,Normal);                                
                                }
                            catch (BadLocationException ble) 
                                {                               
                            System.err.println("Error");
                                }                                  
                }
                
                if ( tempD.get(tempD.YEAR) == selectedDate.get(selectedDate.YEAR) &&
                        tempD.get(tempD.MONTH) == selectedDate.get(selectedDate.MONTH) &&
                        tempD.get(tempD.DAY_OF_MONTH) == selectedDate.get(selectedDate.DAY_OF_MONTH) &&
                        direction == 2 &&
                        data.getInt(i,"fromKm")>= data.getInt(i,"toKm")) 
                      
                {                                                                                                                                         
                      Zugbezeichnung = data.getString(i, "trainName");
                      Zugbezeichnung = fillup(Zugbezeichnung,8);
                      Datumergebnis = tempD.getTime().toLocaleString();
                      Datumergebnis = Datumergebnis.substring(10);
                      Datumergebnis = Datumergebnis.trim();
                      Abfahrtsort = data.getString(i, "fromName");
                      Abfahrtsort = fillup(Abfahrtsort,25);
                      Ankunftsort = data.getString(i, "toName");
                      Ankunftsort = fillup(Ankunftsort,25);
                      Datumergebnis2 = tempTo.getTime().toLocaleString();
                      Datumergebnis2 = Datumergebnis2.substring(10);
                      Datumergebnis2 = Datumergebnis2.trim();
                      String Ausgabe = Zugbezeichnung +"   "+ Datumergebnis + "  "+ Abfahrtsort +"      "+ Ankunftsort +"  "+ Datumergebnis2;
   
                      SimpleAttributeSet Normal = new SimpleAttributeSet();                      
                      StyleConstants.setFontFamily(Normal,"Courier");                     
                      StyleConstants.setFontSize(Normal, 11);
                      StyleConstants.setAlignment(Normal, 1);
                      StyleConstants.setSpaceAbove(Normal, 5);
                      
                            try{                              
                                doc.insertString(doc.getLength(), Ausgabe + newline ,Normal);                                
                                }
                            catch (BadLocationException ble) 
                                {                               
                            System.err.println("Error");
                                }                                  
                }
                
            }
           
            return SelectedfromDateString;
        }      
        
        /**
         * defines working format
         * @param Zugbezeichnung current train
         * @param x desired length for the string
         * @return returns working string
         */
        public String fillup(String Zugbezeichnung,int x) {
            
            int aktuelleLaenge = Zugbezeichnung.length();
            int gewuenschteLaenge = x;
            int Differenz = gewuenschteLaenge - aktuelleLaenge;
            
            for ( int i = 1; i <= Differenz; i++ ) 
                                    {
                                    Zugbezeichnung += " ";                  
                                    }


            return Zugbezeichnung;
        }      
    }
}